<template>
  <div>
    <b-field>
      <b-autocomplete rounded
                      v-model="userSearch"
                      :data="usersMatched"
                      field="email"
                      :placeholder="$t('user.search')"
                      icon="search"
                      clearable
                      @input="debouncedSearch"
                      @select="goToUserPage">
        <template slot-scope="props">
          <div class="media">
            <div class="media-left">
              <img width="32" src="https://picsum.photos/600/400">
            </div>
              {{ props.option.email }}
          </div>
        </template>
      </b-autocomplete>
    </b-field>

    <h2 class="is-size-4 is-capitalized first-letter-colored">
      {{ user.email.split('@')[0] }}
    </h2>

    <b-tabs size="is-medium" class="block"
            destroy-on-hide
            header-class="has-text-weight-bold">
      <b-tab-item :label="$t('user.tab.scores')"
                  icon="trophy"
                  header-class="is-capitalized k-title">
        <user-scores-tab :scores="scores"
                         :loading="loading"
                         :stars="userStars"
                         :v1Total="user.v1_total"
                         :periodRank="user.v1_period_rank"
                         :trophies="user.trophies"
                         :feathersCount="user.feathers_count" />
      </b-tab-item>

      <b-tab-item :label="$t('user.tab.stats')"
                  icon="chart-line"
                  header-class="is-capitalized k-title">
        <user-stats-tab />
      </b-tab-item>
    </b-tabs>

  </div>
</template>

<script lang="ts">
import { Component } from 'vue-property-decorator';

import UserScoresTab from '@/components/users/UserScoresTab.vue';
import UserStatsTab from '@/components/users/UserStatsTab.vue';
import { Score, StarObject, Trophies } from '@/types/scores';
import LoadingMixin from '../../mixins/loading.vue';

import { TranslateResult } from 'vue-i18n';
import { debounce, groupBy, mapValues } from 'lodash';
import { SET_STARS } from '@/store';

export interface User {
  id: number;
  email: string;
  v1_total: number;
  v1_period_rank?: number;
  trophies?: Trophies;
  feathers_count?: number;
}

@Component({
  components: { UserScoresTab, UserStatsTab }
})
export default class UserIndex extends LoadingMixin {
  user: User = {
    id: 0,
    email: '',
    v1_total: 0,
    feathers_count: 0,
  };
  scores: Score[] = [];
  userSearch: string = '';
  usersMatched: User[] = [];
  debouncedSearch: () => void = debounce(this.searchUsers,
                                         1000, { leading: true });

  async mounted() {
    const userId = this.$route.params.id
                   || this.$store.getters.user.id;
    const { data } = await this.$http.get(
      `users/show/${userId}`
    );

    this.user = data.user;
    this.scores = data.scores;
    localStorage.setItem('stars', JSON.stringify(this.userStars));
    // Cache logged user stars for sidebar stars
    if (userId === this.$store.getters.user.id) {
      this.$store.commit(SET_STARS, this.userStars);
    }
    this.stopLoading();
  }

  async searchUsers() {
    if (!this.userSearch)
      return;

    const { data } = await this.$http.get(
      `users/search/${this.userSearch}`
    );

    this.usersMatched = data;
  }

  goToUserPage(selected: User) {
    this.$router.push({
      name: 'User',
      params: { id: String(selected.id) }
    });
  }

  get userStars(): StarObject {
    return mapValues(
      groupBy(this.scores, 'star'),
      'length',
    );
  }
}
</script>

<style lang="scss">
.tile {
  margin: 1rem;
  &-stars {
    padding: 0.75rem;
    justify-content: center;
  }
}
.tile-stars .progress {
  /* FIX tooltip not working
  (https://github.com/buefy/buefy/issues/534) */
  width: 400px;
}
</style>
